SystemOrganization addCategory: #'SqueakPeopleStats-Model'!
SystemOrganization addCategory: #'SqueakPeopleStats-UI'!

WAComponent subclass: #SQPComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-UI'!

SQPComponent subclass: #SQPMainView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-UI'!

!SQPMainView classSide methodsFor: 'testing' stamp: 'gsa 1/18/2008 21:10'!
canBeRoot
	^ true! !

!SQPMainView classSide methodsFor: 'accessing' stamp: 'gsa 1/27/2008 09:12'!
description
	^ 'SqueakPeople Statistics'! !

!SQPMainView classSide methodsFor: 'initialization' stamp: 'gsa 1/27/2008 08:50'!
initialize
	(self registerAsApplication: 'SqueakPeopleStats')
		preferenceAt: #sessionClass put: SQPSession
		
! !

!SQPMainView methodsFor: 'as yet unclassified' stamp: 'gsa 1/27/2008 09:12'!
goWith: aCertification
	self call: ((SQPReportWithAllPeople1 newWithCertification: aCertification)
		addMessage: 'SqueakPeople by Certification';
		"addDecoration: (WADelayedAnswerDecoration new delay: 3);"
		yourself)! !

!SQPMainView methodsFor: 'rendering' stamp: 'gsa 1/27/2008 08:50'!
renderContentOn: html

html heading: 'SqueakPeople Certification Data'.
html horizontalRule.

	html paragraph: 'Clicking on the certification link should show the people with that title.'.

	html paragraph: [
		html anchor
			callback: [ self goWith: ' Master ' ];
			with: 'Master' ].

	html paragraph: [
		html anchor
			callback: [ self goWith: ' Journeyer ' ];
			with: 'Journeyer' ].

	html paragraph: [
		html anchor
			callback: [ self goWith: ' Apprentice ' ];
			with: 'Apprentice' ].

	html paragraph: [
		html anchor
			callback: [ self goWith: ' Observer ' ];
			with: 'Observer' ].

html horizontalRule.


! !

SQPComponent subclass: #SQPReportWithAllPeople1
	instanceVariableNames: 'report certification totalPeopleWithThisCertification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-UI'!

!SQPReportWithAllPeople1 classSide methodsFor: 'as yet unclassified' stamp: 'gsa 1/20/2008 10:41'!
newWithCertification: aCertification.
	^self new
		initializeCertification: aCertification;
		yourself! !

!SQPReportWithAllPeople1 methodsFor: 'accessing' stamp: 'gsa 1/20/2008 10:48'!
certification
	^ certification! !

!SQPReportWithAllPeople1 methodsFor: 'accessing' stamp: 'gsa 1/20/2008 10:46'!
certification: aCertification
certification := aCertification! !

!SQPReportWithAllPeople1 methodsFor: 'accessing' stamp: 'gsa 1/19/2008 08:47'!
children
	^Array with: report! !

!SQPReportWithAllPeople1 methodsFor: 'initialization' stamp: 'gsa 1/20/2008 10:57'!
initializeCertification: aCertification
	super initialize.
	certification := aCertification.
	self initializeReport.
	! !

!SQPReportWithAllPeople1 methodsFor: 'initialization' stamp: 'gsa 1/27/2008 09:46'!
initializeReport
	| preRows rows columns |

	"rows := self session domainmodel people."
	preRows := SQPSystem current people.

	"The substrings after certification is to avoid the #13 char on the data parsed from the web page at last position of certification"
  	rows := preRows select:[:each | each certification substrings = self certification substrings ] thenCollect:[:each | each].

	totalPeopleWithThisCertification := rows size.

"ToDo - Column name with link to page of person on SqueakPeople"		
"	columns := OrderedCollection new add: ((WAReportColumn selector: #name title: ' Name ')
					clickBlock: [:row | WARenderLoop new
							call: (KpProjectViewer new project: row)]);
"

	columns := OrderedCollection new add: (WAReportColumn selector: #name title: ' Name ');
				
					add: (WAReportColumn selector: #alias title: ' Alias ');
					
					add: (WAReportColumn selector: #certification title: ' Certification ');
				 yourself.
	
	report := WATableReport new rows: rows;
				 columns: columns;
				 yourself.
	report rowPeriod: 1.
	report rowColors: {'lightblue'. 'lightyellow'}.
	! !

!SQPReportWithAllPeople1 methodsFor: 'rendering' stamp: 'gsa 1/27/2008 09:49'!
renderContentOn: html
	html horizontalRule.
	
	html text: 'Currently ', totalPeopleWithThisCertification asString, ' persons are certified as ', certification, '.'.

	html horizontalRule.

	html render: report.

	! !

WASession subclass: #SQPSession
	instanceVariableNames: ''
	classVariableNames: 'SQPModel'
	poolDictionaries: ''
	category: 'SqueakPeopleStats-UI'!

!SQPSession methodsFor: 'model' stamp: 'gsa 1/19/2008 08:58'!
domainmodel
	SQPModel isNil ifTrue: [ SQPModel := SQPSystem current ].
	^SQPModel! !

!SQPSession methodsFor: 'as yet unclassified' stamp: 'gsa 1/19/2008 10:39'!
respond: aBlock
| resp |
^ super respond:
	[:url |
		resp := aBlock value: url.
		resp contentType: 'text/html; charset=iso-5589-2'.
		resp]! !

Object subclass: #SQPObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-Model'!

SQPObject subclass: #SQPCertification
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-Model'!

!SQPCertification methodsFor: 'initialize-release' stamp: 'gsa 1/17/2008 09:03'!
initialize
	self name: String new.! !

!SQPCertification methodsFor: 'accessing' stamp: 'gsa 1/17/2008 09:03'!
name
	^ name! !

!SQPCertification methodsFor: 'accessing' stamp: 'gsa 1/17/2008 09:03'!
name: anObject
	name := anObject! !

SQPObject subclass: #SQPHistoryRecord
	instanceVariableNames: 'date numberOfMasters numberOfJourneyers numberOfApprentices numberOfObservers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-Model'!

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:31'!
date
	^ date! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:31'!
date: anObject
	date := anObject! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfApprentices
	^ numberOfApprentices! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfApprentices: anObject
	numberOfApprentices := anObject! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfJourneyers
	^ numberOfJourneyers! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfJourneyers: anObject
	numberOfJourneyers := anObject! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:32'!
numberOfMasters
	^ numberOfMasters! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:32'!
numberOfMasters: anObject
	numberOfMasters := anObject! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfObservers
	^ numberOfObservers! !

!SQPHistoryRecord methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:33'!
numberOfObservers: anObject
	numberOfObservers := anObject! !

!SQPObject methodsFor: 'as yet unclassified' stamp: 'gsa 1/17/2008 09:01'!
= anObject
	^self name = anObject name.! !

!SQPObject methodsFor: 'as yet unclassified' stamp: 'gsa 1/17/2008 09:01'!
hash
^self name hash.
! !

SQPObject subclass: #SQPPerson
	instanceVariableNames: 'name alias certification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-Model'!

!SQPPerson classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 15:13'!
new 
"The person must be created with its instvars not empty" 
^self error: 'Create class ', self name, ' with the method newWithname:alias:certification:'.! !

!SQPPerson classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 15:15'!
newWithName: aName alias: anAlias certification: aCertification

^ self basicNew name: aName; 
	alias: anAlias;
	certification: aCertification; yourself.! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/17/2008 10:40'!
alias
	
	^ alias! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/17/2008 11:48'!
alias: anObject 
	alias := anObject! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/26/2008 18:07'!
certification
	
	^ certification! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/17/2008 11:49'!
certification: anObject 
	certification := anObject! !

!SQPPerson methodsFor: 'initialization' stamp: 'gsa 1/17/2008 10:42'!
initializeName: nameString password: passwordString
	"Initialize the receiver's name and password"

	name := nameString.
	alias := passwordString.! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/17/2008 09:11'!
name
	"Answer the receiver's name"
	
	^ name! !

!SQPPerson methodsFor: 'accessing' stamp: 'gsa 1/17/2008 11:48'!
name: anObject 
	name := anObject! !

Object subclass: #SQPSystem
	instanceVariableNames: 'dateOfPeopleData people history lastUpdate icons errorFileException tempObjectsForLoad checkpointNumber mutex isDirty kpProcess1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakPeopleStats-Model'!

SQPSystem class
	instanceVariableNames: 'Current'!

!SQPSystem commentStamp: 'gsa 4/18/2008 13:42' prior: 0!
Useful Commands:
============

" Check if the history collection already has the current data people, if not, add it"
SQPSystem current checkHistoryByCurrentPeopleData.

" Delete the current content of people collection "
SQPSystem current initializePeople.

" Load the people collection reading the page on SqueakPeople "
SQPSystem current loadPeople.


Requires:
======

HTMLParser
Yaxo
Network-HTML!

SQPSystem class
	instanceVariableNames: 'Current'!

!SQPSystem classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 08:57'!
Current
	^Current! !

!SQPSystem classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 08:57'!
current
"Return the only instance of this class." 
	Current isNil ifTrue: [Current := self basicNew initialize].
	 ^Current! !

!SQPSystem classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 08:57'!
new 
"There is only one of these, so don't let the user make a new one!!" 
^self error: 'Class ', self name, ' cannot create new instances. Try ', self name, ' current'.! !

!SQPSystem classSide methodsFor: 'instance creation' stamp: 'gsa 1/17/2008 08:57'!
reset 
"Reset the only instance of this class." 
Current := nil! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 4/18/2008 11:43'!
addHistory: aHistoryRecord
		history detect: [:each | each date = aHistoryRecord date] ifNone: [history add: aHistoryRecord].! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 1/17/2008 15:29'!
addPerson: aPerson
		people detect: [:each | each name = aPerson name] ifNone: [people add: aPerson].! !

!SQPSystem methodsFor: 'utilities - icon creation' stamp: 'gsa 1/17/2008 08:57'!
base64ContentsOfFileNamed: aString 
	"Private - convenient method"

	| file base64Contents |

	file := FileStream readOnlyFileNamed: aString.
	base64Contents := (Base64MimeConverter mimeEncode: file binary) contents.
	file close.

	^ base64Contents.
! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 4/18/2008 11:52'!
checkHistoryByCurrentPeopleData

"Check if the history collection already has the current data on people collection"
history detect: [:each | each date = self dateOfPeopleData] ifNone: [self saveCurrentPeopleData].
! !

!SQPSystem methodsFor: 'actions' stamp: 'gsa 1/17/2008 08:57'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/17/2008 08:57'!
compressFile: aFileStream
	"Shamelessly copied and modified from StandardFileStream>>compressFile."
	
	| zipped buffer |
	aFileStream binary.
	zipped := self directory newFileNamed: (aFileStream name, 'gz').
	zipped binary; setFileTypeToObject.
	"Type and Creator not to be text, so can be enclosed in an email"
	zipped := GZipWriteStream on: zipped.
	buffer := ByteArray new: 50000.
	[[aFileStream atEnd] whileFalse: [
		zipped nextPutAll: (aFileStream nextInto: buffer)]]
		ensure: [zipped close.aFileStream close].
	self directory deleteFileNamed: aFileStream name! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/17/2008 08:57'!
createCheckpointNumber: number
	"Export me using an ImageSegment.
	This is used for checkpointing the map on disk
	in a form that can be brought into an independent image.
	We do not overwrite older versions, since using ImageSegments
	is an intermediate hack anyway we don't care about the disk waste!!
	Sidenote: Some refactoring was needed to produce a .gz file directly so
	I didn't bother."

	| is fname stream oldMutex|
	"directory := '/home/garduino/Desktop/38SS'."
	fname := self filename, '.', number asString, '.s'.
	(self directory fileExists: fname) ifTrue: [self error: 'Checkpoint already exists!!'].
	stream := self directory newFileNamed: fname.
	checkpointNumber := number.
	oldMutex := mutex.
	mutex := nil. "self clearCaches."
	[is := ImageSegment new.
	is copyFromRoots: ("Array with: self" Array with: KpSystem current) sizeHint: 1000000 areUnique: true.
	is writeForExportOn: stream.
	"Con la siguiente lnea se habilita la compresin del segmento"
	"self compressFile: (self directory oldFileNamed: fname)."
	isDirty := false]
		ensure: [mutex := oldMutex].
	^is! !

!SQPSystem methodsFor: 'utilities - icon creation' stamp: 'gsa 1/17/2008 08:57'!
createIconNamed: aString fromDirectory: directoryString 
	" 
	ApSystem instance
		createIconNamed: 'edit' fromDirectory: '/home/dgd/Desktop/'.
	"

	| png base64 selector source |

	png := directoryString , aString , '.png'.
	base64 := self base64ContentsOfFileNamed: png.

	selector := (aString , 'IconContents') asSymbol.
	((self respondsTo: selector) and: [(self perform: selector) = base64]) ifFalse:[
		source := self iconContentsSourceTemplate format: { aString. png. base64 }.
		self class compile: source classified: 'private - icons'.
	].

	selector := (aString , 'Icon') asSymbol.
	(self respondsTo: selector) ifFalse:[
		source := self iconSourceTemplate format: { aString }.
		self class compile: source classified: 'private - icons'.
	].

	self initializeIcons.
! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/27/2008 10:58'!
dataIn
"|rr|
rr := ReferenceStream fileNamed: 'sectores.obj'.
KpSystem current sectors: rr next.
rr close.
rr := ReferenceStream fileNamed: 'categorias.obj'.
KpSystem current categories: rr next.
rr close.
rr := ReferenceStream fileNamed: 'prioridades.obj'.
KpSystem current priorities: rr next.
rr close.
rr := ReferenceStream fileNamed: 'estados.obj'.
KpSystem current status: rr next.
rr close.
rr := ReferenceStream fileNamed: 'iniciativas.obj'.
KpSystem current projects: rr next.
rr close.
rr := ReferenceStream fileNamed: 'ssectores.obj'.
KpSystem current sSectors: rr next.
rr close."! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/27/2008 10:58'!
dataOut
"|rr|
rr := ReferenceStream fileNamed: 'sectores.obj'.
rr nextPut: KpSystem current sectors.
rr close.
rr := ReferenceStream fileNamed: 'categorias.obj'.
rr nextPut: KpSystem current categories.
rr close.
rr := ReferenceStream fileNamed: 'prioridades.obj'.
rr nextPut: KpSystem current priorities.
rr close.
rr := ReferenceStream fileNamed: 'estados.obj'.
rr nextPut: KpSystem current status.
rr close.
rr := ReferenceStream fileNamed: 'iniciativas.obj'.
rr nextPut: KpSystem current projects.
rr close.
rr := ReferenceStream fileNamed: 'ssectores.obj'.
rr nextPut: KpSystem current sSectors.
rr close."! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:45'!
dateOfPeopleData
	^ dateOfPeopleData! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:45'!
dateOfPeopleData: anObject
	dateOfPeopleData := anObject! !

!SQPSystem methodsFor: 'configuration' stamp: 'gsa 1/17/2008 08:57'!
defaultColor
	"Answer the default color for the receiver. Useful for views."

	^  Color r: 0.7 g: 1.0 b: 0.8 "Color lightGreen"! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 08:57'!
directory
	"Return the subdirectory that SqueakMap uses."
	
	| dir |
	"dir := '/home/garduino/Desktop/38SS'."
	"dir := 'C:\Documents and Settings\garduino\Mis documentos\gsa\Squeak\38SS\'."
	dir := 'tmpSeg'.
	(FileDirectory default directoryExists: dir)
		ifFalse:[FileDirectory default createDirectory: dir].
	^FileDirectory default directoryNamed: dir! !

!SQPSystem methodsFor: 'private - icons' stamp: 'gsa 1/17/2008 08:57'!
editIcon
	"GENERATED METHOD - see #createIconNamed:fromDirectory:"
	^ icons
			at: #'edit'
			ifAbsentPut:[ self formFromBase64Contents: self editIconContents ].! !

!SQPSystem methodsFor: 'private - icons' stamp: 'gsa 1/17/2008 08:57'!
editIconContents
	"GENERATED METHOD - based64 contents of the file /home/dgd/Desktop/edit.png, see #createIconNamed:fromDirectory:"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAABHNCSVQICAgIfAhkiAAAABl0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'! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 08:57'!
errorFileException
	^errorFileException! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 08:57'!
errorFileException: anObject
	errorFileException := anObject! !

!SQPSystem methodsFor: 'utilities - icon creation' stamp: 'gsa 1/17/2008 08:57'!
formFromBase64Contents: aString 
	"Private - Answer a form with the content of the given based64-string"
	| stream |
	stream := Base64MimeConverter mimeDecodeToBytes: aString readStream.
	^ ShoreForm fromBinaryStream: stream.! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 4/18/2008 11:36'!
history
	"Returns the receiver's history"
	history isNil
		ifTrue: [self initializeHistory].
	^ history! !

!SQPSystem methodsFor: 'comparing' stamp: 'gsa 4/18/2008 12:14'!
howManyWithThisCertification: aCertification
	"Count how many people with this certification are on the people collection"

	| rows |
	
	"ojo substrings"
	
  	rows := people select:[:each | each certification substrings = aCertification substrings] thenCollect:[:each | each].

	^ rows size.! !

!SQPSystem methodsFor: 'utilities - icon creation' stamp: 'gsa 1/17/2008 08:57'!
iconContentsSourceTemplate
	"PRIVATE - Answer the template to create a method to hold the content of the icon file"
	^ '{1}IconContents
	"GENERATED METHOD - based64 contents of the file {2}, see #createIconNamed:fromDirectory:"
	^ ''{3}'''
! !

!SQPSystem methodsFor: 'utilities - icon creation' stamp: 'gsa 1/17/2008 08:57'!
iconSourceTemplate
	"PRIVATE - Answer the template to create a method to create and store the icon form"
	^ '{1}Icon
	"GENERATED METHOD - see #createIconNamed:fromDirectory:"
	^ icons
			at: #''{1}''
			ifAbsentPut:[ self formFromBase64Contents: self {1}IconContents ].'
! !

!SQPSystem methodsFor: 'initialization' stamp: 'gsa 1/27/2008 11:05'!
initializeForDeployment
	"Initialize the receiver for a deployment environment"

	self flag: #todo.  "Removes the user"
	"self createUserNamed: 'garduino' password:'tester'."
	super initialize.
! !

!SQPSystem methodsFor: 'initialization' stamp: 'gsa 1/17/2008 08:57'!
initializeForTesting
	"Initialize the receiver for testing"
! !

!SQPSystem methodsFor: 'initialization' stamp: 'gsa 4/18/2008 11:36'!
initializeHistory
	"Private - Initializes the receiver's history"
	history := OrderedCollection new.! !

!SQPSystem methodsFor: 'initialization' stamp: 'gsa 1/17/2008 08:57'!
initializeIcons
	"Initialize the receiver's icons"
	"
	KpSystem current initializeIcons.
	"
	| methods |
	icons := IdentityDictionary new.

	methods := self class selectors select: [:each | '*Icon' match: each asString].
	methods do: [:each | self perform: each].
! !

!SQPSystem methodsFor: 'initialization' stamp: 'gsa 1/17/2008 15:33'!
initializePeople
	"Private - Initializes the receiver's people"
	people := OrderedCollection new.! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 08:57'!
kpProcess1
	^ kpProcess1! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/17/2008 08:57'!
loadAllModel
	"Load not existing model data from tempObjects (Data taken from XML Files)"

" La siguiente rutina es porque el read de archivos sixx necesita una coleccin vaca para meter los datos, pero pone los datos (que tambin son colecciones) como colecciones dentro de esa coleccion vacia, asi que generando un nuevo objecto temporario de tipo Object, meto despus el contenido de temObjectsForLoad evitando el anidamiento de colecciones. "

"| tmpCollection |
tmpCollection := Object new."

self class SystemForLoad: Object new.

"KpSystem current tempObjectsForLoad do: 
		[:each | self class SystemForLoad: each]."

" No lo uso por ahora"
self class SystemForLoad: tempObjectsForLoad.

self halt.

"tempObjectsForLoad do: "
"KpSystem current: tmpCollection."
"KpSystem current."
KpSystem restoreFrom: tempObjectsForLoad.

"tmpCollection do: 
		[:each | KpSystem current: each]."
				
		
"tmpCollection := nil.	"
! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 4/18/2008 12:31'!
loadPeople
	"Read the page http://people.squeakfoundation.org/person/, build person objects and load people collection"

| url urlPage parsedPage|

self dateOfPeopleData: Date today.

url := 'http://people.squeakfoundation.org/person/'.


urlPage := HTTPSocket httpGetDocument: url.

parsedPage := HTMLParser parseDocumentFrom: urlPage.

"(((parsedPage elements last) elements last) elements first) elements explore. "

"Remove of first element (the h1 of the body elements)"
((((parsedPage elements last) elements last) elements first) elements) removeFirst. 


(((parsedPage elements last) elements last) elements first) elements do: [:each | self loadSQPPerson: each ].
! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 1/26/2008 18:48'!
loadSQPPerson: anObject
"Build and return a SQPPerson object"

| tmpSQPPerson namePerson aliasPerson certificationPerson stringNameAndCertification stringNameAndCertificationCollection |

" Store name of person "
aliasPerson := anObject elements first elements first.

" Get string with name and certification in the form:  a a, Observer&#13; "
" string is to make the element return it string instvar, because the element itself is a XMLStringNode "

stringNameAndCertification := anObject elements last string.

stringNameAndCertificationCollection :=  stringNameAndCertification findTokens: ','. 

namePerson := stringNameAndCertificationCollection first.
certificationPerson := stringNameAndCertificationCollection last.

tmpSQPPerson := SQPPerson newWithName: namePerson alias: aliasPerson certification: certificationPerson.

Transcript show: 'Adding ',namePerson,' to people collection'; cr.

people add: tmpSQPPerson.



! !

!SQPSystem methodsFor: 'login' stamp: 'gsa 1/17/2008 08:57'!
loginName: nameString password: passwordString
	"Try to login the user answering a the User object or nil"

	^ users
			detect: [:each | each name = nameString and:[each password = passwordString]]
			ifNone: [nil].
! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 15:32'!
people
	"Returns the receiver's people"
	people isNil
		ifTrue: [self initializePeople].
	^ people! !

!SQPSystem methodsFor: 'objects from disk' stamp: 'gsa 1/17/2008 08:57'!
readXmlFile: aXmlFile
	"Read the xml file with data to be loaded into a temporary object and load temporary object"
	| xmlFile |
     [xmlFile := SixxReadStream readOnlyFileNamed: aXmlFile asString.]
		on: FileDoesNotExistException
		do: [:ex | self errorFileException: 'El archivo ',aXmlFile,' no existe'.
			^ self].
	[xmlFile atEnd] whileFalse: [tempObjectsForLoad add: xmlFile next].
	xmlFile close.! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removeCategory: aCategory 
"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "
		categories do: [:each | each name = aCategory name
					ifTrue: [categories remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removePriority: aPriority 

"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "

		priorities do: [:each | each name = aPriority name
					ifTrue: [priorities remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removeProject: aProject 

"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "


		projects do: [:each | each name = aProject name
					ifTrue: [projects remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removeSector: aSector 


"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "


		sectors do: [:each | each name = aSector name
					ifTrue: [sectors remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removeStatus: aStatus 


"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "


		status do: [:each | each name = aStatus name
					ifTrue: [status remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removeUsers: aUser 

"Falta implementar el tema usuarios"

		users do: [:each | each name = aUser name
					ifTrue: [users remove: each]].! !

!SQPSystem methodsFor: 'removing' stamp: 'gsa 1/17/2008 08:57'!
removesSector: asSector 


"Por ahora compara nombre, pero podra ser solo la comparacin de los objetos, ya que a nivel KpObject se redefini el #="
"	La -integridad referencial- se implement a nivel KpEdit "


		sSectors do: [:each | each name = asSector name
					ifTrue: [sSectors remove: each]].! !

!SQPSystem methodsFor: 'adding' stamp: 'gsa 4/18/2008 12:17'!
saveCurrentPeopleData

"Add summarized Squeak People Data on history collection"
| newHistoryRecord |

newHistoryRecord := SQPHistoryRecord new.
newHistoryRecord date: self dateOfPeopleData.
newHistoryRecord numberOfMasters: (self howManyWithThisCertification: 'Master').
newHistoryRecord numberOfJourneyers: (self howManyWithThisCertification: 'Journeyer').
newHistoryRecord numberOfApprentices: (self howManyWithThisCertification: 'Apprentice').
newHistoryRecord numberOfObservers: (self howManyWithThisCertification: 'Observer').

history add: newHistoryRecord.! !

!SQPSystem methodsFor: 'actions' stamp: 'gsa 1/17/2008 08:57'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

!SQPSystem methodsFor: 'actions' stamp: 'gsa 1/17/2008 08:57'!
saveImageProcess: aProcess seconds: aSeconds

kpProcess1 := [[true] whileTrue:

        [(Delay forSeconds: aSeconds) wait.

         Smalltalk snapshot: true andQuit: false

        ]

] forkAt: 49 named: aProcess.


! !

!SQPSystem methodsFor: 'accessing' stamp: 'gsa 1/17/2008 08:57'!
tempObjectsForLoad

	tempObjectsForLoad isNil
		ifTrue: [self initializeTempObjectsForLoad].
	^ tempObjectsForLoad! !

!SQPSystem methodsFor: 'actions' stamp: 'gsa 1/17/2008 08:57'!
terminateProcess: aProcess
	kpProcess1 terminate.
! !
SQPMainView initialize!
